Index: /trunk/src/sh_hash.c
===================================================================
--- /trunk/src/sh_hash.c	(revision 584)
+++ /trunk/src/sh_hash.c	(revision 1)
@@ -20,14 +20,18 @@
 #include "config_xor.h"
 
+/* define this if you want version 1.3 style database file */
+/* #define OLD_BUG */
+
+/* make sure state changes of a file are always reported, even
+ *  with reportonlyonce=true
+ */
+/* #define REPLACE_OLD *//* moved to samhain.h */
+
 #include <stdlib.h>
 #include <string.h>
 #include <stdio.h>
 #include <sys/types.h>
-#ifdef HAVE_SYS_SYSMACROS_H
-#include <sys/sysmacros.h>
-#endif
 #include <sys/stat.h>
 #include <unistd.h>
-#include <ctype.h>
 
 #ifdef MAJOR_IN_MKDEV
@@ -43,71 +47,252 @@
 #endif
 
-
 #if defined(SH_WITH_CLIENT) || defined(SH_STANDALONE)
 
-#include "samhain.h"
+#include "sh_hash.h"
 #include "sh_utils.h"
-#include "sh_unix.h"
-#include "sh_dbIO_int.h"
-#include "sh_dbIO.h"
-#include "sh_hash.h"
 #include "sh_error.h"
 #include "sh_tiger.h"
-#include "sh_sig.h"
+#include "sh_gpg.h"
 #include "sh_unix.h"
 #include "sh_files.h"
 #include "sh_ignore.h"
-#include "sh_pthread.h"
 
 #if defined(SH_WITH_CLIENT)
-#include "sh_xfer.h"
-#endif
-
-
-#define SH_KEY_NULL _("000000000000000000000000000000000000000000000000")
-
+#include "sh_forward.h"
+#endif
 
 #undef  FIL__
 #define FIL__  _("sh_hash.c")
 
-SH_MUTEX_INIT(mutex_hash,PTHREAD_MUTEX_INITIALIZER);
-
 static char * all_items (file_type * theFile, char * fileHash, int is_new);
 
-static const char  *policy[] = {
-  N_("[]"),
-  N_("[ReadOnly]"),
-  N_("[LogFiles]"),
-  N_("[GrowingLogs]"),
-  N_("[IgnoreNone]"),
-  N_("[IgnoreAll]"),
-  N_("[Attributes]"),
-  N_("[User0]"),
-  N_("[User1]"),
-  N_("[User2]"),
-  N_("[User3]"),
-  N_("[User4]"),
-  N_("[Prelink]"),
-  NULL
-};
-
-static int report_checkflags = S_FALSE;
-int set_report_checkflags(const char * c)
-{
-  return sh_util_flagval(c, &report_checkflags);
-}
-int get_report_checkflags()
-{
-  return report_checkflags;
-}
-
-
-
-const char * sh_hash_getpolicy(int class)
-{
-  if (class > 0 && class < SH_ERR_T_DIR)
-    return _(policy[class]);
-  return _("[indef]");
-}
+#define QUOTE_CHAR '='
+
+static char * unquote_string (char * str)
+{
+  int    i = 0, j, k = 0, len;
+  char * tmp;
+
+  SL_ENTER(_("unquote_string"));
+
+  if (str == NULL)
+    {
+      SL_RETURN(NULL, _("unquote_string"));
+    }
+
+  len = sl_strlen(str);
+
+  tmp = SH_ALLOC(len + 1);
+  for (j = 0; j <= len; ++j)
+    {
+      if (str[j] == QUOTE_CHAR && j < (len-2))
+	{
+	  if (sh_util_hexchar(str[j+1]) >= 0 && sh_util_hexchar(str[j+2]) >= 0)
+	    {
+	      i = 16 * sh_util_hexchar(str[j+1]) + sh_util_hexchar(str[j+2]);
+	      tmp[k] = i; j += 2;
+	    }
+	  else
+	    {
+	      tmp[k] = str[j];
+	    }
+	}
+      else
+	tmp[k] = str[j];
+      ++k;
+    }
+  SL_RETURN(tmp, _("unquote_string"));
+}
+
+static char i2h[2];
+
+char * int2hex (unsigned char i)
+{
+  int j, k;
+
+  j = i / 16;
+  k = i - (j*16);
+  if (j < 10) 
+    i2h[0] = '0'+j;
+  else
+    i2h[0] = 'A'+(j-10);
+  
+  if (k < 10) 
+    i2h[1] = '0'+k;
+  else
+    i2h[1] = 'A'+(k-10);
+
+  return i2h;
+}
+
+static char * quote_string (char * str)
+{
+  int    i = 0, j, k = 0, len;
+  char * tmp;
+  char * tmp2;
+
+  SL_ENTER(_("quote_string"));
+
+  if (str == NULL)
+    {
+      SL_RETURN(NULL, _("quote_string"));
+    }
+
+  len = sl_strlen(str);
+
+  for (j = 0; j < len; ++j)
+    if (str[j] == '\n' || str[j] == QUOTE_CHAR) ++i;
+
+  tmp = SH_ALLOC(len + 1 + 3*i);
+  for (j = 0; j <= len; ++j)
+    {
+      if (str[j] == '\n')
+	{
+	  tmp2 = int2hex((unsigned char) '\n'); /* was 'n', fixed in 1.5.4 */
+	  tmp[k] = QUOTE_CHAR; ++k;
+	  tmp[k] = tmp2[0];    ++k;
+	  tmp[k] = tmp2[1];
+	}
+      else if (str[j] == QUOTE_CHAR)
+	{
+	  tmp2 = int2hex((unsigned char) QUOTE_CHAR);
+	  tmp[k] = QUOTE_CHAR; ++k;
+	  tmp[k] = tmp2[0];    ++k;
+	  tmp[k] = tmp2[1];
+	}
+      else
+	{
+	  tmp[k] = str[j];
+	}
+      ++k;
+    }
+  SL_RETURN(tmp, _("quote_string"));
+}
+
+static UINT32 * swap_32 (UINT32 * iptr)
+{
+#ifdef WORDS_BIGENDIAN
+  unsigned char swap;
+  unsigned char * ii = (unsigned char *) iptr;
+  swap = ii[0]; ii[0] = ii[3]; ii[3] = swap;
+  swap = ii[1]; ii[1] = ii[2]; ii[2] = swap;
+  return iptr;
+#else
+  return iptr;
+#endif
+}
+
+static UINT64 *  swap_64 (UINT64 * iptr)
+{
+#ifdef WORDS_BIGENDIAN
+#ifdef UINT64_IS_32
+  swap_32 ((UINT32*) iptr);
+#else
+  unsigned char swap;
+  unsigned char * ii = (unsigned char *) iptr;
+  swap = ii[0]; ii[0] = ii[7]; ii[7] = swap;
+  swap = ii[1]; ii[1] = ii[6]; ii[6] = swap;
+  swap = ii[2]; ii[2] = ii[5]; ii[5] = swap;
+  swap = ii[3]; ii[3] = ii[4]; ii[4] = swap;
+#endif
+  return iptr;
+#else
+  return iptr;
+#endif
+}
+
+static unsigned short *  swap_short (unsigned short * iptr)
+{
+#ifdef WORDS_BIGENDIAN
+  if (sizeof(short) == 4)
+    swap_32 ((UINT32*) iptr);
+  else
+    {
+      /* alignment problem */
+      unsigned char swap;
+      static unsigned short ooop;
+      unsigned char * ii;
+      ooop = *iptr;
+      ii = (unsigned char *) &ooop;
+      /* printf("SWAP0: %hd  %d\n", *iptr, sizeof(unsigned short)); */
+      swap = ii[0]; ii[0] = ii[1]; ii[1] = swap;
+      /* printf("SWAP1: %hd\n", (unsigned short) ooop); */
+#ifndef OLD_BUG
+      return &ooop;
+#endif
+    }
+  return iptr;
+#else
+  return iptr;
+#endif
+}
+
+
+/* MAX_PATH_STORE must be >= KEY_LEN
+ */
+#define MAX_PATH_STORE 12287
+
+typedef struct store_info {
+  /*
+  char             fullpath[MAX_PATH_STORE+2];
+  char             linkpath[MAX_PATH_STORE+2];
+  */
+  UINT32           mode;
+  UINT32           linkmode;
+
+  UINT64           dev;
+  UINT64           rdev;
+  UINT32           hardlinks;
+  UINT32           ino;
+  UINT64           size;
+  UINT64           atime;
+  UINT64           mtime;
+  UINT64           ctime;
+  UINT32           owner;
+  UINT32           group;
+
+#ifdef OLD_BUG
+#if defined(__linux__)
+  UINT32           attributes;
+  char             c_attributes[16];
+#endif
+#else
+  /* #if defined(__linux__) */
+  UINT32           attributes;
+  char             c_attributes[16];
+  /* endif                  */
+#endif
+  unsigned short   mark;
+  char             c_owner[USER_MAX+2];
+  char             c_group[GROUP_MAX+2];
+  char             c_mode[11];
+  char             checksum[KEY_LEN+1];
+} sh_filestore_t;
+  
+typedef struct file_info {
+  sh_filestore_t   theFile;
+  char           * fullpath;
+  char           * linkpath;
+  int              visited;
+  int              reported;
+  int              allignore;
+  unsigned long    modi_mask;
+  struct           file_info * next;
+} sh_file_t;
+
+  static char  *policy[] = {
+    N_("[]"),
+    N_("[ReadOnly]"),
+    N_("[LogFiles]"),
+    N_("[GrowingLogs]"),
+    N_("[IgnoreNone]"),
+    N_("[IgnoreAll]"),
+    N_("[Attributes]"),
+    N_("[User0]"),
+    N_("[User1]"),
+    N_("[Prelink]"),
+    NULL
+  };
+
 
 /**********************************
@@ -120,4 +305,21 @@
 #include "sh_hash.h"
 
+/* must fit an int              */
+#define TABSIZE 2048  
+
+/* must fit an unsigned short   */
+/* changed for V0.8, as the     */
+/* database format has changed  */
+
+/* changed again for V0.9       */
+/* #define REC_MAGIC 19         */
+/* changed again for V1.3       */
+#ifdef OLD_BUG
+#define REC_MAGIC 20
+#else
+/* changed again for V1.4       */
+#define REC_MAGIC 21
+#endif
+
 
 /**************************************************************
@@ -126,7 +328,10 @@
  *
  **************************************************************/
-file_type * sh_hash_create_ft (const sh_file_t * p, char * fileHash)
+static file_type * sh_hash_create_ft (const sh_file_t * p, char * fileHash)
 {
   file_type * theFile;
+#if defined(__linux__)
+  int i = 16;
+#endif
 
   SL_ENTER(_("sh_hash_create_ft"));
@@ -136,17 +341,18 @@
   sl_strlcpy(theFile->c_mode, p->theFile.c_mode, 11);
   theFile->mode  =  p->theFile.mode;
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
-  sl_strlcpy(theFile->c_attributes, p->theFile.c_attributes, ATTRBUF_SIZE);
+#if defined(__linux__)
+  sl_strlcpy(theFile->c_attributes, p->theFile.c_attributes, i /* 16 */);
   theFile->attributes =  p->theFile.attributes;
 #endif
 
   sl_strlcpy(theFile->fullpath, p->fullpath, PATH_MAX);
-  if (p->linkpath != NULL /* && theFile->c_mode[0] == 'l' */)
-    {
-      theFile->link_path = sh_util_strdup(p->linkpath);
-    }
-  else
-    {
-      theFile->link_path = NULL;
+  if (p->linkpath != NULL && theFile->c_mode[0] == 'l')
+    {
+      sl_strlcpy(theFile->linkpath, p->linkpath, PATH_MAX);
+    }
+  else
+    {
+      theFile->linkpath[0] = '-';
+      theFile->linkpath[1] = '\0';
     }
   sl_strlcpy(fileHash, p->theFile.checksum, KEY_LEN+1);
@@ -167,52 +373,25 @@
   theFile->dev   =  p->theFile.dev;
   theFile->hardlinks = p->theFile.hardlinks;
-  theFile->check_flags = p->theFile.checkflags;
-
-  if (p->attr_string)
-    theFile->attr_string = sh_util_strdup(p->attr_string);
-  else
-    theFile->attr_string = NULL;
 
   SL_RETURN((theFile), _("sh_hash_create_ft"));
 }
 
-struct two_sh_file_t {
-  sh_file_t * prev;
-  sh_file_t * this;
-};
-
-static sh_file_t * hashsearch (const char * s);
-static int hashsearch_prev (const char * s, struct two_sh_file_t * a, int * index); 
-
+static sh_file_t * hashsearch (char * s);
+
+static sh_file_t * tab[TABSIZE];
 
 /**************************************************************
  *
- * >>>> The internal database <<<
+ * compute hash function
  *
  **************************************************************/
-
-static sh_file_t * tab[TABSIZE];
-
-sh_file_t ** get_default_data_table()
-{
-  return tab;
-}
-
-/**************************************************************
- *
- * compute hash function
- *
- **************************************************************/
-
-static int hashfunc(const char *s) 
-{
-  unsigned int n = 0; 
+static int hashfunc(char *s) 
+{
+  unsigned n = 0; 
 
   for ( ; *s; s++) 
     n = 31 * n + *s; 
-
-  return n & (TABSIZE - 1); /* % TABSIZE */; 
+  return n % TABSIZE; 
 } 
-
 
 int hashreport_missing( char *fullpath, int level)
@@ -223,12 +402,6 @@
   file_type * theFile;
   char * str;
-  char hashbuf[KEYBUF_SIZE];
-  volatile int  retval;
 
   /* --------  find the entry for the file ----------------       */
-
-  SH_MUTEX_LOCK(mutex_hash);
-
-  retval = 0;
 
   if (sl_strlen(fullpath) <= MAX_PATH_STORE) 
@@ -237,39 +410,18 @@
     p = hashsearch( sh_tiger_hash(fullpath, 
 				  TIGER_DATA, 
-				  sl_strlen(fullpath),
-				  hashbuf, sizeof(hashbuf))
+				  sl_strlen(fullpath))
 		    );
   if (p == NULL)
-    {
-      retval = -1;
-      goto unlock_and_return;
-    }
+    return -1;
 
   theFile = sh_hash_create_ft (p, fileHash);
   str = all_items(theFile, fileHash, 0);
   tmp = sh_util_safe_name(fullpath);
-
-  SH_MUTEX_LOCK(mutex_thread_nolog);
-  if (!sh_global_check_silent)
-    sh_error_handle (level, FIL__, __LINE__, 0, 
-		     MSG_FI_MISS2, tmp, str);
-  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-  ++sh.statistics.files_report;
-
+  sh_error_handle (level, FIL__, __LINE__, 0, 
+		   MSG_FI_MISS2, tmp, str);
   SH_FREE(tmp);
   SH_FREE(str);
-  if (theFile->attr_string) SH_FREE(theFile->attr_string);
-  if (theFile->link_path)   SH_FREE(theFile->link_path);
   SH_FREE(theFile);
-
- unlock_and_return:
-  ; /* 'label at end of compound statement */
-  SH_MUTEX_UNLOCK(mutex_hash);
-
-  /* remove here to avoid second message from hash_unvisited */
-  if (retval == 0)
-    sh_hash_remove (fullpath);
-
-  return retval;
+  return 0;
 }
 
@@ -280,25 +432,4 @@
  *
  **************************************************************/
-static sh_file_t * delete_db_entry(sh_file_t *p)
-{
-  if (p->fullpath)
-    {
-      SH_FREE(p->fullpath);
-      p->fullpath = NULL;
-    }
-  if (p->linkpath)
-    {
-      SH_FREE(p->linkpath);
-      p->linkpath = NULL;
-    }
-  if (p->attr_string)
-    {
-      SH_FREE(p->attr_string);
-      p->attr_string = NULL;
-    }
-  SH_FREE(p);
-  return NULL;
-}
-
 static void hash_unvisited (int j, 
 			    sh_file_t *prev, sh_file_t *p, ShErrLevel level)
@@ -310,5 +441,7 @@
   char   fileHash[KEY_LEN + 1];
   file_type * theFile;
+
   char * str;
+
 
   SL_ENTER(_("hash_unvisited"));
@@ -322,42 +455,38 @@
     }
 
-  /* Not a fully qualified path, i.e. some info stored by some module
+  /* Kernel info
    */
-  if (p->fullpath[0] != '/')
+  if (p->fullpath[0] == 'K')
     {
       SL_RET0(_("hash_unvisited"));
     }
 
-  /* visited   flag not set: not seen; 
-   * checked   flag     set: not seen (i.e. missing), and already checked 
-   * reported  flag not set: not reported yet
-   * allignore flag not set: not under IgnoreAll
+  /* visited   = FALSE: not seen; 
+   * visited   = 99:    not seen, and already checked 
+   * reported  = FALSE: not reported yet
+   * allignore = FALSE: not under IgnoreAll
    *
    * Files/directories under IgnoreAll are noticed as missing already
    * during the file check.
    */
-  if (((!SH_FFLAG_VISITED_SET(p->fflags)) || SH_FFLAG_CHECKED_SET(p->fflags)) 
-      && (!SH_FFLAG_REPORTED_SET(p->fflags))
-      /* && (!SH_FFLAG_ALLIGNORE_SET(p->fflags)) */)
+  if ((p->visited == S_FALSE || p->visited == 99) && p->reported == S_FALSE 
+      && p->allignore == S_FALSE)
     {
       i = retry_lstat(FIL__, __LINE__, p->fullpath, &buf);
 
-     /* if file does not exist
+      /* if file does not exist
        */
       if (0 != i)
 	{
-	  ptr = sh_util_dirname (p->fullpath);
+	  ptr = sh_util_basename (p->fullpath);
 	  if (ptr)
 	    {
 	      /* If any of the parent directories is under IgnoreAll
 	       */
-	      if ((0 != sh_files_is_allignore(ptr)) || SH_FFLAG_ALLIGNORE_SET(p->fflags))
+	      if (0 != sh_files_is_allignore(ptr))
 		level = ShDFLevel[SH_LEVEL_ALLIGNORE];
 	      SH_FREE(ptr);
 	    }
-
-	  /* Only report if !SH_FFLAG_CHECKED_SET
-	   */
-	  if (!SH_FFLAG_CHECKED_SET(p->fflags))
+	  if (p->visited != 99)
 	    {
 	      if (S_FALSE == sh_ignore_chk_del(p->fullpath))
@@ -367,11 +496,7 @@
 		  theFile = sh_hash_create_ft (p, fileHash);
 		  str = all_items(theFile, fileHash, 0);
-		  if (!sh_global_check_silent)
-		    sh_error_handle (level, FIL__, __LINE__, 0, 
-				     MSG_FI_MISS2, tmp, str);
-		  ++sh.statistics.files_report;
+		  sh_error_handle (level, FIL__, __LINE__, 0, 
+				   MSG_FI_MISS2, tmp, str);
 		  SH_FREE(str);
-		  if (theFile->attr_string) SH_FREE(theFile->attr_string);
-		  if (theFile->link_path)   SH_FREE(theFile->link_path);
 		  SH_FREE(theFile);
 
@@ -380,11 +505,19 @@
 	    }
 
-	  /* We rewrite the db on update, thus we need to keep this
+	  /* We rewrite the db on update, thus we need to push this out
 	   * if the user does not want to purge it from the db.
 	   */
-
-	  if ((sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE) || 
-	      (S_TRUE == sh.flag.update && S_TRUE == sh_util_ask_update(p->fullpath)))
+	  if (sh.flag.checkSum == SH_CHECK_INIT && 
+	      sh.flag.update   == S_TRUE &&
+	      S_FALSE          == sh_util_ask_update(p->fullpath))
 	    {
+	      theFile = sh_hash_create_ft (p, fileHash);
+	      sh_hash_pushdata (theFile, fileHash);
+	      SH_FREE(theFile);
+	    }
+
+	  if (sh.flag.reportonce == S_TRUE)
+	    {
+#ifdef REPLACE_OLD
 	      /* Remove the old entry
 	       */
@@ -393,14 +526,26 @@
 	      else
 		prev->next = p->next;
-
-	      delete_db_entry(p);
-
+	      if (p->fullpath)
+		{
+		  SH_FREE(p->fullpath);
+		  p->fullpath = NULL;
+		}
+	      if (p->linkpath)
+		{
+		  SH_FREE(p->linkpath);
+		  p->linkpath = NULL;
+		}
+	      SH_FREE(p);
+	      p = NULL;
 	      SL_RET0(_("hash_unvisited"));
+#else
+	      p->reported = S_TRUE; 
+#endif
 	    }
 	}
     }
 
-  else if (SH_FFLAG_VISITED_SET(p->fflags) && SH_FFLAG_REPORTED_SET(p->fflags) 
-	   && (!SH_FFLAG_ALLIGNORE_SET(p->fflags)))
+  else if (p->visited == S_TRUE && p->reported == S_TRUE 
+	   && p->allignore == S_FALSE)
     {
       if (S_FALSE == sh_ignore_chk_new(p->fullpath))
@@ -410,11 +555,7 @@
 	  theFile = sh_hash_create_ft (p, fileHash);
 	  str = all_items(theFile, fileHash, 0);
-	  if (!sh_global_check_silent)
-	    sh_error_handle (level, FIL__, __LINE__, 0, 
-			     MSG_FI_MISS2, tmp, str);
-	  ++sh.statistics.files_report;
+	  sh_error_handle (level, FIL__, __LINE__, 0, 
+			   MSG_FI_MISS2, tmp, str);
 	  SH_FREE(str);
-	  if (theFile->attr_string)
-	    SH_FREE(theFile->attr_string);
 	  SH_FREE(theFile);
 
@@ -422,17 +563,13 @@
 	}
 
-      CLEAR_SH_FFLAG_REPORTED(p->fflags);
+      p->reported = S_FALSE;
     }
 
   if (sh.flag.reportonce == S_FALSE)
-    CLEAR_SH_FFLAG_REPORTED(p->fflags);
-
-  CLEAR_SH_FFLAG_VISITED(p->fflags);
-  CLEAR_SH_FFLAG_CHECKED(p->fflags);
-  SET_SH_FFLAG_ENOENT(p->fflags);
-
+    p->reported = S_FALSE;
+
+  p->visited = S_FALSE;
   SL_RET0(_("hash_unvisited"));
 }
-
 
 
@@ -447,6 +584,4 @@
 
   SL_ENTER(_("sh_hash_unvisited"));
-
-  SH_MUTEX_LOCK(mutex_hash);
   for (i = 0; i < TABSIZE; ++i)
     {
@@ -454,120 +589,5 @@
 	hash_unvisited (i, tab[i], tab[i], level);
     }
-  SH_MUTEX_UNLOCK(mutex_hash);
-
   SL_RET0(_("hash_unvisited"));
-}
-
-/*********************************************************************
- *
- * Remove a single file from the database.
- *
- *********************************************************************/
-void sh_hash_remove_unconditional (const char * path)
-{
-  struct two_sh_file_t entries;
-  int index;
-
-  SL_ENTER(_("sh_hash_remove_unconditional"));
-
-  SH_MUTEX_LOCK(mutex_hash);
-  if (0 == hashsearch_prev (path, &entries, &index))
-    {
-      sh_file_t * p = entries.this;
-      
-      /* Remove the old entry
-       */
-      if (entries.prev == p)
-	tab[index] = p->next;
-      else
-	entries.prev->next = p->next;
-      
-      delete_db_entry(p);
-    }
-  SH_MUTEX_UNLOCK(mutex_hash);
-
-  SL_RET0(_("sh_hash_remove_unconditional"));
-}
-
-void sh_hash_remove (const char * path)
-{
-  SL_ENTER(_("sh_hash_remove"));
-
-  if ((sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE) || 
-      (S_TRUE == sh.flag.update && S_TRUE == sh_util_ask_update(path)))
-    {
-      sh_hash_remove_unconditional (path);
-    }
-  SL_RET0(_("sh_hash_remove"));
-}
-
-
-/*********************************************************************
- *
- * Search for unvisited entries in the database, custom error handler.
- *
- *********************************************************************/
-void sh_hash_unvisited_custom (char prefix, void(*handler)(const char * key))
-{
-  int i;
-  sh_file_t *p    = NULL;
-  sh_file_t *prev = NULL;
-  sh_file_t *next = NULL;
-
-  SL_ENTER(_("sh_hash_unvisited_custom"));
-
-  SH_MUTEX_LOCK(mutex_hash);
-  for (i = 0; i < TABSIZE; ++i)
-    {
-      if (tab[i] != NULL)
-	{
-	  p = tab[i]; prev = p;
-
-	  do 
-	    {
-	      next = p->next;
-
-	      if (p->fullpath && 
-		  prefix == p->fullpath[0])
-		{
-		  if ((!SH_FFLAG_VISITED_SET(p->fflags)) 
-		      && (!SH_FFLAG_REPORTED_SET(p->fflags)))
-		    {
-		      handler(p->fullpath);
-
-		      if (!SH_FFLAG_CHECKED_SET(p->fflags))
-			{
-			  /* delete */
-			  if (tab[i] == p)
-			    {
-			      tab[i] = p->next;
-			      prev   = tab[i];
-			      next   = prev;
-			    }
-			  else
-			    {
-			      prev->next = p->next;
-			      next       = prev->next;
-			    }
-
-			  p = delete_db_entry(p);
-			}
-		    }
-		  if (p)
-		    {
-		      CLEAR_SH_FFLAG_VISITED(p->fflags);
-		      CLEAR_SH_FFLAG_CHECKED(p->fflags);
-		    }
-		}
-	      if (p)
-		prev = p;
-	      p    = next;
-	    } 
-	  while (p);
-	}
-    }
-  SH_MUTEX_UNLOCK(mutex_hash);
-
-  SL_RET0(_("hash_unvisited_custom"));
 }
 
@@ -597,9 +617,4 @@
       SH_FREE(p->linkpath);
       p->linkpath = NULL;
-    }
-  if (p->attr_string)
-    {
-      SH_FREE(p->attr_string);
-      p->attr_string = NULL;
     }
   SH_FREE(p);
@@ -614,5 +629,5 @@
  *
  ***********************************************************************/
-static sh_file_t * hashsearch (const char * s) 
+static sh_file_t * hashsearch (char * s) 
 {
   sh_file_t * p;
@@ -620,43 +635,13 @@
   SL_ENTER(_("hashsearch"));
 
-  if (s)
-    {
-      for (p = tab[hashfunc(s)]; p; p = p->next)
-	if ((p->fullpath != NULL) && (0 == strcmp(s, p->fullpath))) 
-	  SL_RETURN( p, _("hashsearch"));
-    } 
+  if (!s)
+    SL_RETURN( NULL, _("hashsearch"));
+
+  for (p = tab[hashfunc(s)]; p; p = p->next) 
+    if ((p->fullpath != NULL) && (0 == strcmp(s, p->fullpath))) 
+      SL_RETURN( p, _("hashsearch")); 
   SL_RETURN( NULL, _("hashsearch"));
 } 
 
-static int hashsearch_prev (const char * s, struct two_sh_file_t * a, int * index) 
-{
-  sh_file_t * this;
-  sh_file_t * prev = NULL;
-
-  SL_ENTER(_("hashsearch_prev"));
-
-  if (s)
-    {
-      *index = hashfunc(s);
-      this   = tab[*index];
-      prev   = this;
-
-      if (this)
-	{
-	  do {
-	    if ((this->fullpath != NULL) && (0 == strcmp(s, this->fullpath)))
-	      {
-		a->prev = prev;
-		a->this = this;	
-		SL_RETURN( 0, _("hashsearch_prev"));
-	      }
-	    prev = this;
-	    this = this->next;
-	  } while(this);
-	} 
-    }
-  SL_RETURN( -1, _("hashsearch"));
-} 
-
 
 /***********************************************************************
@@ -665,8 +650,7 @@
  *
  ***********************************************************************/
-void hashinsert (sh_file_t * mtab[TABSIZE], sh_file_t * s) 
+static void hashinsert (sh_file_t * s) 
 {
   sh_file_t * p;
-  sh_file_t * q;
   int key;
 
@@ -675,36 +659,34 @@
   key = hashfunc(s->fullpath);
 
-  if (mtab[key] == NULL) 
-    {
-      mtab[key] = s;
-      mtab[key]->next = NULL;
+  if (tab[key] == NULL) 
+    {
+      tab[key] = s;
+      tab[key]->next = NULL;
       SL_RET0(_("hashinsert"));
     } 
   else 
     {
-      p = mtab[key];
+      p = tab[key];
       while (1) 
 	{
-	  if (p && p->fullpath && 0 == strcmp(s->fullpath, p->fullpath))
+	  if (p && p->fullpath && 
+	      0 == strcmp(s->fullpath, p->fullpath) &&
+	      strlen(s->fullpath) == strlen(p->fullpath))
 	    {
-	      q = p->next;
-	      SH_FREE(p->fullpath);
-	      if(p->linkpath)    SH_FREE(p->linkpath);
-	      if(p->attr_string) SH_FREE(p->attr_string);
-	      memcpy(p, s, sizeof(sh_file_t));
-	      p->next = q;
-	      SH_FREE(s); s = NULL;
+	      SH_FREE(s->fullpath);
+	      if(s->linkpath)
+		SH_FREE(s->linkpath);
+	      SH_FREE(s);
+	      s = NULL;
 	      SL_RET0(_("hashinsert"));
 	    }
-	  else if (p && p->next == NULL) 
-	    {
-	      p->next = s;
-	      p->next->next = NULL;
-	      SL_RET0(_("hashinsert"));
-	    }
-	  if (p)
-	    p = p->next;
-	  else /* cannot really happen, but llvm/clang does not know */
-	    break;
+	  else 
+	    if (p->next == NULL) 
+	      {
+		p->next = s;
+		p->next->next = NULL;
+		SL_RET0(_("hashinsert"));
+	      }
+	  p = p->next;
 	}
     }
@@ -713,7 +695,43 @@
 
 
-
 /******************************************************************
  *
+ * Get a single line
+ *
+ ******************************************************************/
+static FILE * sh_fin_fd = NULL;
+
+static int sh_hash_getline (FILE * fd, char * line, int sizeofline)
+{
+  register int  n = 0;
+  char        * res;
+
+  if (sizeofline < 2) {
+    line[0] = '\0';
+    return 0;
+  }
+  res = fgets(line, sizeofline, fd);
+  if (res == NULL)
+    {
+      line[0] = '\0';
+      return -1;
+    }
+  n = strlen(line);
+  if (n > 1) {
+    --n;
+    line[n] = '\0';
+  }
+  return n;
+}
+
+static void sh_hash_getline_end ()
+{
+  fclose (sh_fin_fd);
+  sh_fin_fd = NULL;
+  return;
+}
+
+/******************************************************************
+ *
  * ------- Check functions -------
  *
@@ -722,15 +740,244 @@
 static int IsInit = 0;
 
-void sh_hash_set_initialized()
-{
-  IsInit = 1;
-  return;
-}
-
-int sh_hash_get_initialized()
-{
-  return IsInit;
-}
-
+
+/******************************************************************
+ *
+ * Fast forward to start of data
+ *
+ ******************************************************************/
+int sh_hash_setdataent (SL_TICKET fd, char * line, int size, char * file)
+{
+  long i;
+  extern int get_the_fd (SL_TICKET ticket);
+
+  SL_ENTER(_("sh_hash_setdataent"));
+
+  sl_rewind (fd);
+
+  if (sh_fin_fd != NULL)
+    {
+      fclose (sh_fin_fd);
+      sh_fin_fd = NULL;
+    }
+
+  sh_fin_fd = fdopen(get_the_fd(fd), "rb");
+  if (!sh_fin_fd)
+    {
+      dlog(1, FIL__, __LINE__, 
+	   _("The file signature database: %s is not readable.\n"),
+	   (NULL == file) ? _("(null)") : file);
+      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_P_NODATA,
+		       ( (NULL == file) ? _("(null)") : file)
+		       );
+      aud_exit (FIL__, __LINE__, EXIT_FAILURE);
+    }
+
+  while (1) 
+    {
+      i =  sh_hash_getline (sh_fin_fd, line, size-1);
+      if (i < 0 ) 
+	{
+	  SH_FREE(line);
+	  dlog(1, FIL__, __LINE__, 
+	       _("The file signature database: %s does not\ncontain any data, or the start-of-file marker is missing (unlikely,\nunless modified by hand).\n"),
+	       (NULL == file) ? _("(null)") : file);
+	       
+	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_P_NODATA,
+			   ( (NULL == file) ? _("(null)") : file)
+			   );
+	  aud_exit (FIL__, __LINE__, EXIT_FAILURE);
+	}
+
+#if defined(SH_STEALTH)
+      if (0 == sl_strncmp (line, N_("[SOF]"), 5)) 
+#else
+      if (0 == sl_strncmp (line, _("[SOF]"),  5)) 
+#endif
+	break;
+    }
+  SL_RETURN( 1, _("sh_hash_setdataent"));
+}
+
+static int sh_hash_setdataent_old (SL_TICKET fd, char * line, int size, 
+				   char * file)
+{
+  long i;
+
+  SL_ENTER(_("sh_hash_setdataent_old"));
+
+  sl_rewind (fd);
+
+  while (1) 
+    {
+      i =  sh_unix_getline (fd, line, size-1);
+      if (i < 0 ) 
+	{
+	  SH_FREE(line);
+	  dlog(1, FIL__, __LINE__, 
+	       _("The file signature database: %s does not\ncontain any data, or the start-of-file marker is missing (unlikely,\nunless modified by hand).\n"),
+	       (NULL == file) ? _("(null)") : file);
+	       
+	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_P_NODATA,
+			   ( (NULL == file) ? _("(null)") : file)
+			   );
+	  aud_exit (FIL__, __LINE__, EXIT_FAILURE);
+	}
+
+#if defined(SH_STEALTH)
+      if (0 == sl_strncmp (line, N_("[SOF]"), 5)) 
+#else
+      if (0 == sl_strncmp (line, _("[SOF]"),  5)) 
+#endif
+	break;
+    }
+  SL_RETURN( 1, _("sh_hash_setdataent_old"));
+}
+
+/******************************************************************
+ *
+ * Read next record
+ *
+ ******************************************************************/
+sh_file_t *  sh_hash_getdataent (SL_TICKET fd, char * line, int size)
+{
+  sh_file_t * p;
+  sh_filestore_t ft;
+  long i;
+  char * fullpath;
+  char * linkpath;
+  char * tmp;
+
+  SL_ENTER(_("sh_hash_getdataent"));
+
+  (void) fd;
+
+  /* Read next record -- Part One 
+   */
+  p = SH_ALLOC(sizeof(sh_file_t));
+
+  i = fread (&ft, sizeof(sh_filestore_t), 1, sh_fin_fd);
+  /* i = sl_read(fd, &ft, sizeof(sh_filestore_t)); */
+  /* if ( SL_ISERROR(i) || i == 0) */
+  if (i < 1)
+    {
+      SH_FREE(p);
+      SL_RETURN( NULL, _("sh_hash_getdataent"));
+    }
+
+  swap_32(&(ft.mode));
+  swap_32(&(ft.linkmode));
+  swap_64(&(ft.dev));
+  swap_64(&(ft.rdev));
+  swap_32(&(ft.hardlinks));
+  swap_32(&(ft.ino));
+  swap_64(&(ft.size));
+  swap_64(&(ft.atime));
+  swap_64(&(ft.mtime));
+  swap_64(&(ft.ctime));
+  swap_32(&(ft.owner));
+  swap_32(&(ft.group));
+#if defined(__linux__)
+  swap_32(&(ft.attributes));
+#endif
+#ifdef OLD_BUG
+  swap_short(&(ft.mark));
+#else
+  ft.mark = *(swap_short(&(ft.mark)));
+#endif
+
+  if (ft.mark != REC_MAGIC)
+    {
+      SH_FREE(p);
+      SL_RETURN( NULL, _("sh_hash_getdataent"));
+    }
+
+  /* Read next record -- Part Two -- Fullpath
+   */
+  i =  sh_hash_getline (sh_fin_fd, line, size-1);
+  if (i < 0 ) 
+    {
+      SH_FREE(line);
+      SH_FREE(p);
+      dlog(1, FIL__, __LINE__, 
+	   _("There is a corrupt record in the file signature database: %s\nThe file path is missing.\n"),
+	   (NULL == file_path('D', 'R'))? _("(null)"):file_path('D', 'R'));
+      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_P_NODATA,
+			   ( (NULL == file_path('D', 'R')) ? _("(null)") :
+			     file_path('D', 'R'))
+			    );
+      aud_exit (FIL__, __LINE__,EXIT_FAILURE);
+    }
+
+  tmp = unquote_string (line);
+  i = sl_strlen(tmp)+1;
+  fullpath = SH_ALLOC(i);
+  sl_strlcpy (fullpath, tmp, i);
+  if (tmp)
+    SH_FREE(tmp);
+  if (fullpath[i-2] == '\n')
+    fullpath[i-2] = '\0';
+
+  /* Read next record -- Part Three -- Linkpath
+   */
+  i =  sh_hash_getline (sh_fin_fd, line, size-1);
+  if (i < 0 ) 
+    {
+      SH_FREE(line);
+      SH_FREE(fullpath);
+      SH_FREE(p);
+      dlog(1, FIL__, __LINE__, 
+	   _("There is a corrupt record in the file signature database: %s\nThe link path (or its placeholder) is missing.\n"),
+	   (NULL == file_path('D', 'R'))? _("(null)"):file_path('D', 'R'));
+      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_P_NODATA,
+		       ( (NULL == file_path('D', 'R')) ? _("(null)") :
+			 file_path('D', 'R'))
+		       );
+      aud_exit (FIL__, __LINE__,EXIT_FAILURE);
+    }
+
+  tmp = unquote_string (line);
+  i = sl_strlen(tmp)+1;
+  linkpath = SH_ALLOC(i);
+  sl_strlcpy (linkpath, tmp, i);
+  if (tmp)
+    SH_FREE(tmp);
+  if (linkpath[i-2] == '\n')
+    linkpath[i-2] = '\0';
+
+  /* Read next record -- Part Four -- Decode
+   */
+#if defined(SH_STEALTH)
+  sh_do_decode(fullpath,    sl_strlen(fullpath));
+  
+#if defined(__linux__)
+  sh_do_decode(ft.c_attributes,   sl_strlen(ft.c_attributes));
+#endif
+  
+  sh_do_decode(ft.c_mode,   sl_strlen(ft.c_mode));
+  sh_do_decode(ft.c_owner,  sl_strlen(ft.c_owner));
+  sh_do_decode(ft.c_group,  sl_strlen(ft.c_group));
+  sh_do_decode(ft.checksum, sl_strlen(ft.checksum));
+  
+  
+  if (ft.c_mode[0] == 'l') 
+    {  
+      sh_do_decode(linkpath, sl_strlen(linkpath));
+    }
+#endif
+
+  memcpy( &(*p).theFile, &ft, sizeof(sh_filestore_t) );
+  p->visited   = S_FALSE;
+  p->reported  = S_FALSE;
+  p->allignore = S_FALSE;
+  p->modi_mask = 0L;
+  p->fullpath  = fullpath;
+  p->linkpath  = linkpath;
+
+  /* set to an invalid value 
+   */
+  ft.mark = (REC_MAGIC + 5);
+
+  SL_RETURN( p, _("sh_hash_getdataent"));
+}
 
 /******************************************************************
